
unit Foxpro;
{**********************************************************}
{*                        dBase.PAS                       *}
{*    ꥪ⭮-ਥ஢ 䥩  DBF-䠩     *}
{*                     Version 0.90 beta                  *}
{*         ᮢ FoxPro  ꥪ TDBF     *}
{*             ⮫쪮            *}
{*            ⪠    beta-ᨨ       *}
{*             뢠 訡 Abstract Method call       *}
{*              Copyright (c) by SoftWeyr,1994            *}
{**********************************************************}
{ ᮢ FoxPro  ꥪ TDBF}
interface
 Uses Objects,DBase;
 { ⥩訩 砩:     - 
  ப,  ᫮,  㭨,  ⥫쭮
  For-ࠦ}
const
 nfLeaf = 2;
 nfRoot = 1;
type PIDXHeader = ^TIDXHeader;
     TIdxHeader=Record
                    RootOffset:LongInt;{⥫  ୥ 設}
                    FreeRecord:LongInt;{⥫  ᢮  ᯨ᪥ 設}
                    FileLen   :LongInt;{⥫   䠩}
                    KeyLen    :Word;
                    Flags     :Byte;
                    ISign     :Byte;
                    KeyFormula:Array[0..219] of char;
                    ForFormula:Array[0..219] of char;
                    Reserved  :Array[0..55] of Char;
                  end;
      PIDXNode=^TIDXNode;
      TIdxNode=Record
                   {This exist only in memory}
                   Next:PIDXNode;
                   Offset:LongInt;
                   CurKey:Word;
                   Modified:Boolean;
                   Unused:Byte;
                   {Here starts a file page (length=512 bytes}
                   NodeAttrs:Word;
                   KeyCount:Word;
                   LeftNode:LongInt;
                   RightNode:LongInt;
                   Keys:Array[0..499] of byte;
                 end;
     PDouble=^Double;
     PLongInt=^LongInt;
     PWord=^Word;

 PIDX = ^TIDX;
 TIDX = object(TIndex)
         KeySize:Word;
         Root:PIDXNode;
         Leaf:PIdxNode;
         Stream:PStream;
         FreePage:Longint;
         Current:LongInt;
         Base:PDbf;{⥫   }
         KeyField:Integer;{ 祢 }

         Constructor Init(AStream:PStream;ABase:PDBF);
         Constructor Make(AStream:PStream;ABase:PDBF;AKeyField:Integer);
         Constructor Create(AStream:PStream;KeyExpr,Forexpr:String;
                        Unique:Boolean;KeyType:IndexType;KeyLen:Integer);
         Function ValidateExpr(Expr:String):boolean;virtual;
         {-------- ஢ ४⭮ ᭮ ࠦ
               KEyField  Typ.  ⮫쪮
             .  ᫮ - ९}
         Procedure CalcKey;virtual;
         {----------  祭   ⥪饣  
                      뢠      Double2Key
                      Str2Asciiz.  ᫮ ᮢ- ९}
         Function isFirst:boolean;virtual;
         Function isLast:boolean;virtual;
         Destructor Done;virtual;
         Function First:LongInt;virtual;
         {------- 頥 ࢮ 祭  浪}
         Function NextKey:LongInt;virtual;
         {------- 頥 ᫥饥 祭 ᫥ ⥪饣  -1}
         Function PrevKey:LongInt;virtual;
         {------ 頥 ।饥 祭  । ⥪騬 
          -1}
         Function SeekStr(Key:String):LongInt;virtual;
         {------  -  砥 ப }
         Function SeekNum(Key:Float):LongInt;virtual;
         {------  -  砥 ᫮ }
         Procedure UpdateKey;virtual;
         {------- 祭   ⥪饩 }
         Function GetCurrentKey:Pointer;
         {-------頥 㪠⥫  ⥪饥 祢 祭}
                 {,  ࠭   饭 ଠ}
         Procedure SetKeyOffset( Offs:LongInt);
         {-------   ,   㪠뢠 ⥪騩 }
         Procedure InsertKey(AOffset:LongInt);
         {------ ⠢ , ᮤঠ 祭 , ᯮ짮
                  ᫥ ᪥   㪠 ஬ }
         Procedure DeleteKey;
         {-------  ⥪騩 }
         Procedure IncRest(RecNo:LongInt);virtual;
         {------稢 뫪      
             ᥩ >=RecNo. ( InsertBlank);}
              Procedure SetPos;virtual;
        {-----⭠    ⥪ }

         Private
          CurEntry:Integer;
          FileSize:LongInt;
          Function Last:LongInt;virtual;
          Procedure LoadPage(var P:PIDXNode;AOffset:LongInt);
          Function Seek:LongInt;
          Function Compare(Page:PIDXNode;K:Integer):Integer;
          Function GetNum(Page:PIDXNode;K:Integer):LongInt;
          Function NewPage:PIDXNode;
          Procedure DestroyPAge(P:PIDXNode);
          Procedure MoveKey(var Src;SrcNum:Integer;var Dest;DestNum:Integer);
          Procedure PutNum(Page:PIDXNode;K:Integer;AOffset:Longint);
          Procedure RemoveKeys(Page:PIDXNode;Start,Count:integer);
          Procedure MakeHole(Page:PIDXNode);
        end;
  PFPT = ^TFPT;
  TFPT = object(TMemoFile)
            BlockSize     : word;
            NextFreeBlock : longint;
            Stream        : PStream;

            constructor Init(AStream : PStream);
            destructor Done; virtual;

            function GetSize(Offset : longint) : word; virtual;
            { 頥  MEMO-   ᬥ饭  䠩 }

            procedure Get(Offset : longint; var D : TMemoRec); virtual;
            { 頥 MEMO-   ᬥ饭  䠩 }

            procedure Free(Offset : longInt); virtual;
            {  MEMO-   ᬥ饭  䠩 }

            function Put(var D : TMemoRec) : longint; virtual;
            { 뢠 MEMO-  䠩 }

            function GetDBFID : byte; virtual;
            { 頥  ⨯ DBF-䠩 (F5 -   砥) }
          end;
Procedure Str2Asciiz(S:String);
Procedure Double2Key(X:Double);
implementation
Function SwapLong(P:LongInt):Longint;assembler;
asm
 MOV AX,P.Word[2]
 XCHG AH,AL
 MOV DX,P.Word[0]
 XCHG DH,DL
end;

var KeyBuffer:Array[0..219] of byte;
Procedure Double2Key(X:Double);
var K:array[0..7] of byte absolute X;
    i:Integer;
begin
 if X<0 then
   for i:=0 to 7 do
    KeyBuffer[7-i]:=not K[i]
  else
   begin
    For i:=0 to 6 do
     KeyBuffer[7-i]:=k[i];
    KeyBuffer[0]:=k[7] xor $80;
  end;
end;
Procedure Str2Asciiz(S:String);
var i:Integer;
begin
 For i:=1 to length(S) do
  KeyBuffer[i-1]:=ord(S[i]);
 FillChar(KeyBuffer[Length(S)],219-Length(S),#0);
end;
Constructor TIDX.Init(AStream:PStream;ABase:PDBF);
var S:String;
    I:Integer;
begin
 TIndex.Init;
 Stream:=AStream;
 New(Root);
 FillChar(Root^,SizeOf(TIDXNode),0);
 Root^.Offset:=-1;
 LoadPage(Root,0);
 With PIdxHeader(@Root^.NodeAttrs)^ do
  begin
   i:=0;
   S:='';
   While (i<=10)and(KeyFormula[i]<>#0) do
    begin
     S:=S+KeyFormula[i];
     inc(i);
    end;
  Base:=ABase;
  FreePage:=FreeRecord;
  KeySize:=KeyLen;
  FileSize:=FileLen;
  LoadPage(Root,RootOffset)
 end;
 if not ValidateExpr(S) then fail;
 if Typ = itpNumeric then
  Current:=SeekNum(Base^.GetRealField(KeyField))
  else
  Current:=SeekStr(Base^.GetField(KeyField));
  DbError:=0;
end;
Constructor TIDX.Make(AStream:PStream;ABase:PDBF;AKeyField:Integer);
var KeyTyp:IndexType;
begin
 if (AKeyField<0)or(AKeyField>ABase^.FieldCount)then
  begin
   Dispose(AStream,Done);
   dbError:=dbInvalidField;
   fail;
  end;
 Case ABase^.FieldType(AKeyField) of
 'N':KeyTyp:=itpNumeric;
 'C':KeyTyp:=itpString;
 else
  dispose(AStream,Done);
  dbError:=dbInvalidType;
  fail;
 end;
 Create(AStream,ABase^.Field(AKeyField),'',False,KeyTyp,ABase^.FieldLen(AKeyField));
 Base:=ABase;
 KeyField:=AKeyField;
 Base^.Go(Top);
 Repeat
  CalcKey;
  Seek;
  InsertKey(Base^.RecNo);
  Base^.Next;
 Until Base^.Eof;
 FillChar(KeyBuffer,KeySize,0);
 Seek;
end;
Constructor TIDX.Create(AStream:PStream;KeyExpr,Forexpr:String;
                        Unique:Boolean;KeyType:IndexType;KeyLen:Integer);
var I:Integer;
    H:TIdxHeader;
    S:FieldNameString;
begin
 TIndex.Init;
 Typ:=KeyType;
 if AStream^.Status<>stOk then
  begin
   dbError:=dbInitError;
   fail;
  end;
 KeySize:=KeyLen;
 if KeySize>100 then
  begin
   Dispose(AStream,Done);
   dbError:=dbRecordTooLarge;
   fail;
  end;
 Stream:=AStream;
 FillChar(H,SizeOf(H),0);
 With H do
  begin
   RootOffset:=512;
   FreeRecord:=-1;
   FileLen:=1024;
   FileSize:=FileLen;
   KeyLen:=KeySize;
   Flags:=0;
   ISign:=1;
   Move(KeyExpr[1],KeyFormula,Length(KeyExpr));
   if ForExpr<>'' then
    begin
     Move(ForExpr[1],ForFormula,Length(ForExpr));
     Flags:=Flags or 8;
    end;
   if Unique then Flags:=Flags or 1;
  end;
 Stream^.Seek(0);
 Stream^.Write(H,512);
 Stream^.Truncate;
 if Stream^.Status<>stOk then
  begin
   Dispose(Stream,Done);
   dbError:=dbInitError;
   Fail;
  end;
 New(Root);
 Leaf:=Root;
 FillChar(Root^,SizeOf(TIDXNode),0);
 With Root^ do
  begin
   NodeAttrs:=nfRoot+nfLeaf;
   LeftNode:=-1;
   RightNode:=-1;
   Offset:=512;
   KeyCount:=0;
   CurKey:=1;
  end;
 FreePage:=-1;
 KeySize:=KeyLen;
end;
Function TIDX.ValidateExpr(Expr:String):Boolean;
begin
  ValidateExpr:=False;
  KeyField:=Base^.FieldNo(Expr);
  if (KeyField=0) then
  begin
   dbError:=dbInvalidIndex;
   Done;
   Exit;
  end;
 if  Base^.FieldType(KeyField)='N' then Typ:=itpNumeric
  else
  if Base^.FieldType(KeyField)='C' then Typ:=itpString
  else begin
   dbError:=dbInvalidIndex;
   Done;
   Exit;
  end;
 ValidateExpr:=True;
end;
Procedure TIDX.CalcKey;
begin
 If Typ=itpNumeric then
   Double2Key(Base^.GetRealField(KeyField))
  else
   Str2Asciiz(Base^.GetField(KeyField));
end;

Destructor TIDX.Done;
var Buf:PIDXNode;
    H:TIDXHeader;
begin
 Stream^.Seek(0);
 Stream^.Read(H,512);
 H.FileLen:=FileSize;
 H.RootOffset:=Root^.Offset;
 H.FreeRecord:=FreePage;
 Stream^.Seek(0);
 Stream^.Write(H,512);
 While Root<>nil do
 begin
  Buf:=Root;
  if Root^.Modified then
   begin
    Stream^.Seek(Root^.Offset);
    Stream^.Write(Root^.Nodeattrs,512);
   end;
  Root:=root^.Next;
  Dispose(Buf);
 end;
 Dispose(Stream,Done);
 TIndex.Done;
end;
Procedure TIDX.LoadPage(var P:PIDXNode;AOffset:LongInt);
begin
 if P=nil then
  begin
   New(P);
   P^.Modified:=False;
   P^.Next:=nil;
  end else if P^.Offset=AOffset then exit;
 if P^.Modified then
  begin
   Stream^.Seek(P^.Offset);
   Stream^.Write(P^.NodeAttrs,512);
   P^.Modified:=False;
  end;
 Stream^.Seek(AOffset);
 Stream^.Read(P^.NodeAttrs,512);
 P^.Offset:=AOffset;
end;

Function TIDX.First:LongInt;
{------- 頥 ࢮ 祭  浪}
var Buf:PIdxNode;
begin
 Buf:=Root;
 While Buf^.NodeAttrs and nfLeaf=0 do
 begin
    LoadPage(Buf^.Next,GetNum(Buf,1));
    Buf^.CurKey:=1;
    Buf:=Buf^.Next;
 end;
 Current:=GetNum(Buf,1);
 First:=Current;
end;
Function TIDX.NextKey:LongInt;
{------- 頥 ᫥饥 祭 ᫥ ⥪饣  -1}
Function Recurse(Page:PIDXNode):Boolean;
begin
 Recurse:=False;
 With Page^ do
 if (NodeAttrs and nfLeaf <>0)or Recurse(Next) then
  begin
   Inc(CurKEy);
   if CurKey>KeyCount then
    begin
     if RightNode<>-1 then
      begin
       LoadPage(Page,RightNode);
       CurKey:=1;
      end;
     Recurse:=True;
    end;
  end;
end;
begin
 if Current=-1 then begin NextKey:=-1;exit end;
 if Current=0 then begin NextKey:=First;exit; end;
 If Recurse(Root) then NextKey:=-1 else
  NextKey:=GetNum(Leaf,Leaf^.CurKey);
end;
Function TIDX.PrevKey:LongInt;
{------ 頥 ।饥 祭  । ⥪騬  -1}
Function Recurse(Page:PIDXNode):Boolean;
begin
 Recurse:=False;
 With Page^ do
 if (NodeAttrs and nfLeaf <>0)or Recurse(Next) then
  begin
   Dec(CurKEy);
   if CurKey=0 then
    begin
     if LeftNode<>-1 then
      begin
       LoadPage(Page,LeftNode);
       CurKey:=Page^.KeyCount;
      end;
     Recurse:=True;
    end;
  end;
end;
begin
 if Current=-1 then begin PrevKey:=Last;exit end;
 if Current=0 then begin PrevKey:=0;exit; end;
 If Recurse(Root) then PrevKey:=0 else
  PrevKey:=GetNum(Leaf,Leaf^.CurKey);
end;
Function TIDX.SeekStr(Key:String):LongInt;
{------  -  砥 ப }
begin
 Str2ASCIIZ(Key);
 SeekStr:=Seek;
end;
Function TIDX.SeekNum(Key:Float):LongInt;
{------  -  砥 ᫮ }
begin
 Double2Key(Key);
 SeekNum:=Seek;
end;

Procedure TIDX.UpdateKey;
{------- 祭   ⥪饩 }
begin
 if Current <>base^.RecNo then
  begin
    SetPos;
    InsertKey(Base^.RecNo)
  end
 else
  begin
   CalcKey;
   if Compare(Leaf,Leaf^.CurKey)<>0 then
    begin
     DeleteKey;
     CalcKey;
     InsertKey(Base^.RecNo);
    end;
  end;
end;
{ਢ }

Function TIDX.GetNum(Page:PIDXNode;K:Integer):LongInt;assembler;
{----------- 頥 뫪, ਭ k-⮬    ࠭}
asm
{ GetNum:=SwapLong(PLongInt(Buf^.Keys[(i-1)*(KeySize+4)+KeySize])^);}
 Les DI,Self
 MOV BX,ES:[DI].TIDX.KeySize
 LES DI,Page
 ADD DI,Offset TIDXNode.Keys
 MOV AX,K
 Dec AX
 MOV DX,BX
 ADD DX,4
 MUL DX
 ADD BX,AX
 MOV DX,ES:[DI+BX]
 ADD BX,2
 MOV AX,ES:[DI+BX]
 XCHG AH,AL
 XCHG DH,DL
end;
Procedure TIDX.PutNum(Page:PIDXNode;K:Integer;AOffset:Longint);assembler;
asm
    LES DI,Self
    MOV BX,ES:[DI].TIDX.KeySize
    LES DI,Page
    ADD DI,Offset TIDXNode.Keys
   {K*(KeySize+4)+KeySize)}
    MOV AX,K
    DEC AX
    MOV DX,BX
    ADD DX,4
    MUL DX
    ADD AX,BX
    ADD DI,AX
    MOV AX,AOffset.Word[2]
    XCHG AH,AL
    CLD
    STOSW
    MOV AX,AOffset.Word[0]
    XCHG AH,AL
    STOSW
end;
Procedure TIDX.MoveKey(var Src;SrcNum:Integer;var Dest;DestNum:Integer);assembler;
asm
    PUSH DS
    LES DI,Self
    MOV CX,ES:[DI].TIDX.KeySize
    MOV BX,CX
    ADD BX,4
    LES DI,Dest
    MOV AX,DestNum
    MUL BX
    ADD DI,AX
    LDS SI,Src
    MOV AX,SrcNum
    MUL BX
    ADD SI,AX
    CLD
    REP MOVSB
    POP DS
end;
Procedure TIDX.RemoveKeys(Page:PIDXNode;Start,Count:integer);assembler;
asm
    LES DI,Self
    MOV BX,ES:[DI].TIDX.KeySize
    ADD BX,4
    LES DI,Page
    MOV AX,ES:[DI].TIDXNode.KeyCount
    SUB AX,Start
    SUB AX,Count
    MUL BX
    MOV CX,AX
    JCXZ @@1
    MOV AX,Start
    DEC AX
    MUL BX
    ADD AX,Offset TIDXNode.Keys
    MOV SI,AX
    PUSH DI
    MOV AX,Count
    MUL BX
    ADD AX,SI
    MOV DI,AX
    PUSH DS
    PUSH ES
    POP DS
    CLD
    REP MOVSB
    POP DS
    POP DI
@@1:MOV AX,Count
    SUB ES:[DI].TIdxNode.KeyCount,AX
end;
Procedure TIDX.MakeHole(Page:PIDXNode);assembler;
asm
   LES DI,Self
   MOV BX,ES:[DI].TIDX.KeySize
   ADD BX,4
   LES DI,Page
   MOV AX,ES:[DI].TIDXNode.KeyCount
   MUL BX
   MOV SI,AX
   DEC SI
   ADD SI,Offset TIDXNode.Keys
   MOV AX,ES:[DI].TIDXNode.KeyCount
   SUB AX,ES:[DI].TIDXNode.CurKey
   MUL BX
   MOV CX,AX{(KeyCount-CurKey)*BX)}
   INC ES:[DI].TIDXNode.KeyCount
   MOV DI,SI
   ADD DI,BX
   JCXZ @@1
   STD
   PUSH DS
   PUSH ES
   POP DS
   REP MOVSB
   POP DS
@@1:
end;

Function TIDX.Compare(Page:PIDXNode;K:Integer):Integer;assembler;
{-------- ࠢ 祭 K   ⥪饩 ࠭   ᮤন
  KeyBuffer}
asm
 Les DI,Self
 MOV CX,ES:[DI].TIDX.KeySize { CX-  }
 LES DI,Page
 ADD DI,Offset TIDXNode.Keys
 MOV AX,K
 Dec AX
 MOV DX,CX
 ADD DX,4
 MUL DX
 ADD DI,AX;{  ES:DI -    }
 MOV SI,offset KeyBuffer;{  DS:SI -  KeyBuffer}
 CLD
 REPZ CMPSB
 JNZ @@1
 SUB AX,AX
 JMP @@X
@@1:
  MOV AX,1
  JA @@X
  NEG AX
@@X:
end;
Function TIDX.Seek:LongInt;
var Page:PIDXNode;
var Shift:Integer;I,L,H,C:Integer;Stop:Boolean;
begin
 Page:=Root;
 With Page^ do
   if Compare(Page,KeyCount)=1 then
    begin
     Seek:=Base^.RecCount+1;
     Root^.CurKey:=0;
     Current:=-1;
     Exit
    end;
 Stop:=False;
 Repeat
  L:=1;

  H:=Page^.KeyCount;
  While L<=H do
   begin
    I:= (L+H) shr 1;
    C:=Compare(Page,i);
    if C>0 then L:=I+1
     else
      begin
       H:= i-1;
       if C=0 then
        L:=I
     end;
  end;
 Page^.CurKey:=L;
 if (Page^.NodeAttrs and nfLeaf=0) then
  begin
    LoadPage(Page^.Next,GetNum(Page,L));
    Page:=Page^.Next;
  end else Stop:=True;
 Until  Stop;
   Current:=GetNum(Page,i);
   Seek:=Current;
   Exact:=C=0;
   If Leaf=nil then Leaf:=Page;
end;
Function TIDX.IsFirst:boolean;
begin
 isFirst:=(Leaf^.CurKey=0)and(Leaf^.LeftNode=-1);
end;
Function TIDX.IsLast:boolean;
begin
 isLast:=(Leaf^.CurKey=Leaf^.KeyCount)and(Leaf^.RightNode=-1);
end;

Function TIDX.Last:LongInt;
{------- 頥 ᫥ 祭  浪}
var Buf:PIDXNode;
begin
 Buf:=Root;
 While Buf^.NodeAttrs and nfLeaf=0 do
  begin
    LoadPage(Buf^.Next,GetNum(Buf,Buf^.KeyCount));


    Buf^.CurKey:=Buf^.KeyCount;
    Buf:=Buf^.Next;
  end;
 Current:=GetNum(Buf,Buf^.KeyCount);
 Buf^.CurKey:=Buf^.KeyCount;
 Last:=Current;
end;
Function TIDX.GetCurrentKey:Pointer;
begin
 GetCurrentKey:=Pointer(LongInt(Leaf)+SizeOf(TIDXNode)-500+Pred(Leaf^.CurKey)*(KeySize+4));
end;
Procedure TIDX.SetKeyOffset(Offs:LongInt);assembler;
asm
 Les DI,Self
 MOV BX,ES:[DI].TIDX.KeySize
 LES DI,ES:[DI].TIDX.Leaf;
 MOV AX,ES:[DI].TIDXNode.CurKey
 ADD DI,Offset TIDXNode.Keys
 Dec AX
 MOV DX,BX
 ADD DX,4
 MUL DX
 ADD BX,AX
 MOV AX,Offs.Word[2]
 MOV ES:[DI+BX],AX
 ADD BX,2
 MOV AX,Offs.Word[0]
 MOV AX,ES:[DI+BX]
 XCHG AH,AL
 XCHG DH,DL
end;
Procedure SwapString(var Src,Dest;Size:Word);assembler;
asm
    Push DS
    LES DI,Src;
    LDS sI,Dest
    MOV CX,Size
    JCXZ @@x
@@1:MOV AL,ES:[DI]
    XCHG AL,[SI]
    STOSB
    INC SI;
    LOOP @@1;
@@X:POP DS
end;
Procedure TIDX.InsertKey(AOffset:LongInt);
var TMPLong:Longint;
    LastKey:array[1..104] of Byte;
    TMPPage:PIdxNode;
Function Recurse(Page:PIDXNode):Boolean;
var P:Boolean;
LocalBuffer:Array[0..99] of char;
i:Integer;
tmp2:PIDXNode;
begin
 if Page^.NodeAttrs and nfLeaf=0
   then P:=Recurse(Page^.Next)
   else P:=True;
 Recurse:=False;
 if P then
   begin
     TMPPage:=nil;
     Move(KeyBuffer,LocalBuffer,KeySize);
     if Page^.KeyCount=500 div (KeySize+4) then
       begin
       { ࠭}
       {  ࠭}
       TMPPage:=NewPage;
       With TMPPage^ do
         begin
           LeftNode:=Page^.LeftNode;
           RightNode:=Page^.Offset;
           Page^.LeftNode:=Offset;
           if LeftNode<>-1 then
            begin
             Tmp2:=nil;
             LoadPage(Tmp2,LeftNode);
             Tmp2^.RightNode:=Offset;
             Stream^.Seek(LeftNode);
             Stream^.Write(TMP2^.NodeAttrs,512);
             Dispose(TMP2);
           end;
         {஢     祩}
           KeyCount:=Succ(Page^.KeyCount) div 2;
           if odd(Page^.KeyCount) and (Page^.CurKey<=KeyCount) then Dec(KeyCount);
           Move(Page^.Keys,Keys,KeyCount*(KeySize+4));
           Dec(Page^.KeyCount,KeyCount);
         {  KeyBuffer ᫥   ࠭}
           For i:=0 to Pred(Page^.KeyCount) do
           Move(Page^.Keys[(KeyCount+i)*(KeySize+4)],
                Page^.Keys[i*(KeySize+4)],(KeySize+4));
           Move(Keys[Pred(KeyCount)*(KeySize+4)],KeyBuffer,KeySize);
           Page^.NodeAttrs:=Page^.NodeAttrs and not nfRoot;
           NodeAttrs:=Page^.NodeAttrs;
         {࠭   ࠭,      }
           if (Page^.CurKey<=KeyCount) then
            begin
             CurKey:=Page^.CurKey;
             Next:=Page^.Next;
            {뢠    ࠭}
             Stream^.Seek(Page^.Offset);
             Stream^.Write(Page^.NodeAttrs,512);
             Page:=TMPPage;
            end
           else
            begin
             Dec(Page^.CurKey,KeyCount);
             {뢠    ࠭}
             Stream^.Seek(Offset);
             Stream^.Write(NodeAttrs,512);
            end;
          Recurse:=True;
         end;{With}
        end;
  For i:=Page^.KeyCount downto Page^.CurKey do
    Move(Page^.Keys[(i-1)*(KeySize+4)],Page^.Keys[i*(KeySize+4)],(KeySize+4));
  Move(LocalBuffer,Page^.Keys[(Page^.CurKey-1)*(KeySize+4)],KeySize);
  Move(TMPLong,Page^.Keys[(Page^.CurKey-1)*(KeySize+4)+KeySize],4);
  Inc(Page^.KeyCount);
  Page^.Modified:=true;
  if TmpPage<>nil then TMPLong:=SwapLong(TmpPage^.Offset);
 end;
end;
begin
TMPLong:=SwapLong(AOffset);
if Root^.KeyCount=0 then
begin
 Move(KeyBuffer,Root^.Keys,KeySize);
 Move(TMPLong,Root^.Keys[KeySize],4);
 Root^.KeyCount:=1;
 Root^.CurKey:=1;
 exit
end;
Move(Root^.Keys[Pred(Root^.KeyCount)*(KeySize+4)],LastKey,KeySize+4);
 if  Current=-1{  ᫥} then
   begin
    { ⠬ Offset ᫥  Leaf  TMPLong}
     With leaf^ do
       begin
         Move(Keys[Pred(KeyCount)*(KeySize+4)+KeySize],AOffset,4);
         Move(TmpLong,Keys[Pred(KeyCount)*(KeySize+4)+KeySize],4);
         TMPLong:=AOffset;
       end;
    {  ⢥ ᫥   ஢ ᮤন KeyBuffer}
    TMPPage:=Root;
    Last;
    While TMPPage<>nil do
      begin
       With TMPPage^ do
        Move(KeyBuffer,Keys[Pred(KeyCount)*(KeySize+4)],KeySize);
        TMPPage:=TMPPage^.Next;
      end;
    { ⠬ KeyBuffer  LastKey}
     SwapString(KeyBuffer,LastKey,KeySize);
   end;
 AOffset:=SwapLong(Root^.Offset);
 if Recurse(Root) then
   begin
    {  ࠭}
    TMPPage:=NewPage;
    With TMPPage^ do
      begin
        LeftNode:=-1;
        RightNode:=-1;
        NodeAttrs:=nfRoot;
    {     KeyBuffer  Root^.Offset;}
        Move(KeyBuffer,Keys,KeySize);
        Move(TMPLong,Keys[KeySize],4);
    {   ࠭ ᫥   Offset}
        Move(LastKey,Keys[(KeySize+4)],KeySize);
        Move(AOffset,Keys[(2*KeySize+4)],4);
        KeyCount:=2;
    {  root     Next 㪠⥫   Root}
        TMPPage^.Next:=Root;
        Root:=TMPPAge;
      end;
   end;
end;
Procedure TIDX.IncRest(RecNo:LongInt);
var Buffer:Array[1..250] of char;
    L:LongInt;
begin
 Move(GetCurrentKey^,Buffer,KeySize);
 Current:=First;
 While Current<>-1 do
  begin
   L:=GetNum(Leaf,Leaf^.CurKey);
   If L>RecNo then SetKeyOffset(L+1);
   Current:=NextKey;
  end;
 Move(Buffer,KEyBuffer,KeySize);
 Current:=Seek;
end;
Procedure TIDX.SetPos;
{-----⭠    ⥪ }
begin
 if Base^.RecNo>Base^.RecCount then begin Current:=Last;Current:=NextKEy end else
 CalcKey;
 Current:=Seek;
end;
Procedure TIDX.DeleteKey;
Function Balance(Page:PIdxNode):boolean;
{ ࠭. 頥 True, ᫨  ᫥  
 ࠭}
begin
end;
Procedure Recurse(Var Page:PIDXNode;var LastChanged,NeedBalance:boolean);
begin
 if Page^.NodeAttrs and nfLeaf<>0 then
  begin
   LastChanged:=Page^.CurKey=Page^.KeyCount;
   RemoveKeys(Page,Page^.CurKey,1);
  end
  else
   begin
    Recurse(Page^.Next,LastChanged,NeedBalance);
    if LastChanged then
     With Page^ do
     begin
      MoveKey(Next^.Keys,Next^.KeyCount,Keys,CurKey);
      LastChanged:=Page^.CurKey=Page^.KeyCount;
     end;
    if NeedBalance then
     begin
      Balance(Page);
     end;
   end;
     NeedBalance:=Page^.KeyCount<(500 div (KeySize+4)) div 2;
end;
var L1,L2:Boolean;
    TMPPage:PIDXNode;
begin
   Recurse(Root,L1,L2);
   if(Root^.KeyCount<=1)
    and(Root^.NodeAttrs and nfLeaf=0)
  then
    begin
     TMPPage:=Root;
     Root:=Root^.Next;
     Root^.NodeAttrs:=Root^.NodeAttrs or nfRoot;
     DestroyPage(Root);
    end;
end;
Function TIDX.NewPage:PIDXNode;
var P:PIDXNode;
begin
 New(P);
 With P^ do
 begin
  Next:=Nil;
  KeyCount:=0;
  Modified:=True;
 end;
 if FreePage=-1 then
  begin
   P^.Offset:=FileSize;
   Inc(FileSize,512);
  end
else
 begin
  P^.Offset:=FreePage;
  Stream^.Seek(P^.Offset);
  Stream^.Read(FreePage,4);
 end;
 NewPage:=P;
end;
Procedure TIDX.DestroyPage(P:PIDXNode);
begin
 Stream^.Seek(P^.Offset);
 Stream^.Write(FreePage,4);
 FreePage:=P^.Offset;
 Dispose(P);
end;

{********************* TFPT object ***************************************}

  constructor TFPT.Init(AStream : PStream);
  begin
    TMemoFile.Init;
    Stream := AStream;

    if Stream^.GetSize=0 then
    begin
      BlockSize := 512;
      NextFreeBlock := 1;
    end else
    begin
      Stream^.Read(NextFreeBlock,4);
      NextFreeBlock:=SwapLong(NextFreeBlock);
      Stream^.Seek(6);
      Stream^.Read(BlockSize,2);
      BlockSize:=Swap(BlockSize);
    end;
  end;

  destructor TFPT.Done;
  begin
    Stream^.Seek(0);
    Stream^.Write(NextFreeBlock,4);
    Dispose(Stream, Done);
  end;

  function TFPT.GetSize(offset : longint) : word;
    var MemoSize : longint;
  begin
    Stream^.Seek((offset*BlockSize)+4);
    Stream^.Read(MemoSize,4);
    GetSize := SwapLong(MemoSize);
  end;

  procedure TFPT.Get(offset : longint; var D : TMemoRec);
  begin
    D.TextLen := GetSize(offset);
    Stream^.Seek((offset*BlockSize)+8);
    Stream^.Read(D.TextData, D.TextLen);
  end;

  procedure TFPT.Free(offset : longInt);
  begin
    Stream^.Seek((offset*BlockSize));
    Stream^.Write(NextFreeBlock,4);
    NextFreeBlock := offset;
  end;

  function TFPT.Put(var D : TMemoRec) : longint;
    var NFreeBl,PrevFreeblock,FoundBlock,
        countBlocks,Size,
        Offset
         : longint;
        Gap:Integer;
        P:Pointer;
  Function FreeSpace(Offset:LongInt):Word;
  begin
   if Offset>=CountBlocks then BlockSize:=$FFFF else
    FreeSpace:=(GetSize(Offset)+BlockSize+7) div BlockSize * BlockSize;
  end;
  begin
    NFreeBl := NextFreeBlock;
    countBlocks := (Stream^.GetSize + BlockSize - 1) div BlockSize;
    PrevFreeBlock:=0;
    while (NFreeBl < countBlocks) and
          (FreeSpace(NFreeBl) < D.TextLen+8) do
    begin     { 室 訩, 㤮⢮騩 ࠧࠬ  }
      Stream^.Seek(NFreeBl*BlockSize);
      PrevFreeBlock:=NFreeBl;
      Stream^.Read(NFreeBl,4);
    end;
    FoundBlock:=NFreeBl;
    Offset:=NFreeBl*BlockSize;
    Stream^.Seek(NFreeBl*BlockSize);
    if NFreebl=CountBlocks then
      begin {Append file}
       With Stream^ do
        Seek(GetSize);
       gap:= Offset-Stream^.GetSize;
       if Gap>0 then
        begin
         GetMem(P,Gap);
         FillChar(P^,Gap,0);
         Stream^.Write(P^,Gap);
         FreeMem(P,Gap);
         NFreeBl:=CountBlocks+(D.TextLen+7+BlockSize) div blockSize;
        end
      end
      else {Read Pointer to next free block}
       begin
        Stream^.Seek(Offset);
        Stream^.Read(NFreeBl,4);
        Stream^.Read(Size,4);
        Size:=(Size+BlockSize-1) div BlockSize - (D.TextLen+7+BlockSize) div BlockSize;
        if Size>0 then
         begin {Create FreeBlock from rest of found block}
          Stream^.Seek(Offset+Size*BlockSize);
          Stream^.Write(NFreeBl,4);
          Stream^.Write(Size,4);
          NFreeBl:=FoundBlock+Size;
         end;
        Stream^.Seek(Offset);
       end;
     Size:=D.TextLen;
     CountBlocks:=1;
     Stream^.Write(CountBlocks,4);
     Stream^.Write(Size,4);
     Stream^.Write(D.TextData,D.TextLen);
     Stream^.Seek(PrevFreeBlock*BlockSize);
     Stream^.Write(NFreeBl,4);
     If PrevFreeBlock=0 then NextFreeBlock:=NFreeBl;
  end;

  function TFPT.GetDBFID: byte;
  begin
    GetDBFID:=$F5;
  end;
end.